diff --git a/src/corelib/io/qdataurl.cpp b/src/corelib/io/qdataurl.cpp
index 27fdaf58e69..974aee2539e 100644
--- a/src/corelib/io/qdataurl.cpp
+++ b/src/corelib/io/qdataurl.cpp
@@ -42,10 +42,11 @@ Q_CORE_EXPORT bool qDecodeDataUrl(const QUrl &uri, QString &mimeType, QByteArray
         }
 
         if (QLatin1StringView{data}.startsWith("charset"_L1, Qt::CaseInsensitive)) {
-            qsizetype i = 7;      // strlen("charset")
-            while (data.at(i) == ' ')
-                ++i;
-            if (data.at(i) == '=')
+            qsizetype prefixSize = 7; // strlen("charset")
+            QByteArrayView copy(data.constData() + prefixSize, data.size() - prefixSize);
+            while (copy.startsWith(' '))
+                copy = copy.sliced(1);
+            if (copy.startsWith('='))
                 data.prepend("text/plain;");
         }
 


